<?php

/* ***********************************************************
 * This file was automatically generated on 2017-01-25.      *
 *                                                           *
 * PHP Bindings Version 2.1.11                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

namespace Tinkerforge;

require_once(__DIR__ . '/IPConnection.php');

/**
 * Measures two DC voltages between -35V and +35V with 24bit resolution each
 */
class BrickletIndustrialDualAnalogIn extends Device
{

    /**
     * This callback is triggered periodically with the period that is set by
     * BrickletIndustrialDualAnalogIn::setVoltageCallbackPeriod(). The parameter is the voltage of the
     * channel.
     * 
     * BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE is only triggered if the voltage has changed since the
     * last triggering.
     */
    const CALLBACK_VOLTAGE = 13;

    /**
     * This callback is triggered when the threshold as set by
     * BrickletIndustrialDualAnalogIn::setVoltageCallbackThreshold() is reached.
     * The parameter is the voltage of the channel.
     * 
     * If the threshold keeps being reached, the callback is triggered periodically
     * with the period as set by BrickletIndustrialDualAnalogIn::setDebouncePeriod().
     */
    const CALLBACK_VOLTAGE_REACHED = 14;


    /**
     * @internal
     */
    const FUNCTION_GET_VOLTAGE = 1;

    /**
     * @internal
     */
    const FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 2;

    /**
     * @internal
     */
    const FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 3;

    /**
     * @internal
     */
    const FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 4;

    /**
     * @internal
     */
    const FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 5;

    /**
     * @internal
     */
    const FUNCTION_SET_DEBOUNCE_PERIOD = 6;

    /**
     * @internal
     */
    const FUNCTION_GET_DEBOUNCE_PERIOD = 7;

    /**
     * @internal
     */
    const FUNCTION_SET_SAMPLE_RATE = 8;

    /**
     * @internal
     */
    const FUNCTION_GET_SAMPLE_RATE = 9;

    /**
     * @internal
     */
    const FUNCTION_SET_CALIBRATION = 10;

    /**
     * @internal
     */
    const FUNCTION_GET_CALIBRATION = 11;

    /**
     * @internal
     */
    const FUNCTION_GET_ADC_VALUES = 12;

    /**
     * @internal
     */
    const FUNCTION_GET_IDENTITY = 255;

    const THRESHOLD_OPTION_OFF = 'x';
    const THRESHOLD_OPTION_OUTSIDE = 'o';
    const THRESHOLD_OPTION_INSIDE = 'i';
    const THRESHOLD_OPTION_SMALLER = '<';
    const THRESHOLD_OPTION_GREATER = '>';
    const SAMPLE_RATE_976_SPS = 0;
    const SAMPLE_RATE_488_SPS = 1;
    const SAMPLE_RATE_244_SPS = 2;
    const SAMPLE_RATE_122_SPS = 3;
    const SAMPLE_RATE_61_SPS = 4;
    const SAMPLE_RATE_4_SPS = 5;
    const SAMPLE_RATE_2_SPS = 6;
    const SAMPLE_RATE_1_SPS = 7;

    const DEVICE_IDENTIFIER = 249;

    const DEVICE_DISPLAY_NAME = "Industrial Dual Analog In Bricklet";

    /**
     * Creates an object with the unique device ID $uid. This object can
     * then be added to the IP connection.
     *
     * @param string $uid
     */
    public function __construct($uid, $ipcon)
    {
        parent::__construct($uid, $ipcon);

        $this->apiVersion = array(2, 0, 0);

        $this->responseExpected[self::FUNCTION_GET_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_TRUE;
        $this->responseExpected[self::FUNCTION_GET_DEBOUNCE_PERIOD] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_SAMPLE_RATE] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_SAMPLE_RATE] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_SET_CALIBRATION] = self::RESPONSE_EXPECTED_FALSE;
        $this->responseExpected[self::FUNCTION_GET_CALIBRATION] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::FUNCTION_GET_ADC_VALUES] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;
        $this->responseExpected[self::CALLBACK_VOLTAGE] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::CALLBACK_VOLTAGE_REACHED] = self::RESPONSE_EXPECTED_ALWAYS_FALSE;
        $this->responseExpected[self::FUNCTION_GET_IDENTITY] = self::RESPONSE_EXPECTED_ALWAYS_TRUE;

        $this->callbackWrappers[self::CALLBACK_VOLTAGE] = 'callbackWrapperVoltage';
        $this->callbackWrappers[self::CALLBACK_VOLTAGE_REACHED] = 'callbackWrapperVoltageReached';
    }

    /**
     * @internal
     * @param string $header
     * @param string $data
     */
    public function handleCallback($header, $data)
    {
        call_user_func(array($this, $this->callbackWrappers[$header['functionID']]), $data);
    }

    /**
     * Returns the voltage for the given channel in mV.
     * 
     * If you want to get the voltage periodically, it is recommended to use the
     * callback BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE and set the period with 
     * BrickletIndustrialDualAnalogIn::setVoltageCallbackPeriod().
     * 
     * @param int $channel
     * 
     * @return int
     */
    public function getVoltage($channel)
    {
        $payload = '';
        $payload .= pack('C', $channel);

        $data = $this->sendRequest(self::FUNCTION_GET_VOLTAGE, $payload);

        $payload = unpack('V1voltage', $data);

        return IPConnection::fixUnpackedInt32($payload, 'voltage');
    }

    /**
     * Sets the period in ms with which the BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE callback is triggered
     * periodically for the given channel. A value of 0 turns the callback off.
     * 
     * BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE is only triggered if the voltage has changed since the
     * last triggering.
     * 
     * The default value is 0.
     * 
     * @param int $channel
     * @param int $period
     * 
     * @return void
     */
    public function setVoltageCallbackPeriod($channel, $period)
    {
        $payload = '';
        $payload .= pack('C', $channel);
        $payload .= pack('V', $period);

        $this->sendRequest(self::FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, $payload);
    }

    /**
     * Returns the period as set by BrickletIndustrialDualAnalogIn::setVoltageCallbackPeriod().
     * 
     * @param int $channel
     * 
     * @return int
     */
    public function getVoltageCallbackPeriod($channel)
    {
        $payload = '';
        $payload .= pack('C', $channel);

        $data = $this->sendRequest(self::FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, $payload);

        $payload = unpack('V1period', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'period');
    }

    /**
     * Sets the thresholds for the BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE_REACHED callback for the given
     * channel.
     * 
     * The following options are possible:
     * 
     * <code>
     *  "Option", "Description"
     * 
     *  "'x'",    "Callback is turned off"
     *  "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
     *  "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
     *  "'<'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
     *  "'>'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
     * </code>
     * 
     * The default value is ('x', 0, 0).
     * 
     * @param int $channel
     * @param string $option
     * @param int $min
     * @param int $max
     * 
     * @return void
     */
    public function setVoltageCallbackThreshold($channel, $option, $min, $max)
    {
        $payload = '';
        $payload .= pack('C', $channel);
        $payload .= pack('c', ord($option));
        $payload .= pack('V', $min);
        $payload .= pack('V', $max);

        $this->sendRequest(self::FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, $payload);
    }

    /**
     * Returns the threshold as set by BrickletIndustrialDualAnalogIn::setVoltageCallbackThreshold().
     * 
     * @param int $channel
     * 
     * @return array
     */
    public function getVoltageCallbackThreshold($channel)
    {
        $result = array();

        $payload = '';
        $payload .= pack('C', $channel);

        $data = $this->sendRequest(self::FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, $payload);

        $payload = unpack('c1option/V1min/V1max', $data);

        $result['option'] = chr($payload['option']);
        $result['min'] = IPConnection::fixUnpackedInt32($payload, 'min');
        $result['max'] = IPConnection::fixUnpackedInt32($payload, 'max');

        return $result;
    }

    /**
     * Sets the period in ms with which the threshold callback
     * 
     * * BrickletIndustrialDualAnalogIn::CALLBACK_VOLTAGE_REACHED
     * 
     * is triggered, if the threshold
     * 
     * * BrickletIndustrialDualAnalogIn::setVoltageCallbackThreshold()
     * 
     * keeps being reached.
     * 
     * The default value is 100.
     * 
     * @param int $debounce
     * 
     * @return void
     */
    public function setDebouncePeriod($debounce)
    {
        $payload = '';
        $payload .= pack('V', $debounce);

        $this->sendRequest(self::FUNCTION_SET_DEBOUNCE_PERIOD, $payload);
    }

    /**
     * Returns the debounce period as set by BrickletIndustrialDualAnalogIn::setDebouncePeriod().
     * 
     * 
     * @return int
     */
    public function getDebouncePeriod()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_DEBOUNCE_PERIOD, $payload);

        $payload = unpack('V1debounce', $data);

        return IPConnection::fixUnpackedUInt32($payload, 'debounce');
    }

    /**
     * Sets the sample rate. The sample rate can be between 1 sample per second
     * and 976 samples per second. Decreasing the sample rate will also decrease the
     * noise on the data.
     * 
     * The default value is 6 (2 samples per second).
     * 
     * @param int $rate
     * 
     * @return void
     */
    public function setSampleRate($rate)
    {
        $payload = '';
        $payload .= pack('C', $rate);

        $this->sendRequest(self::FUNCTION_SET_SAMPLE_RATE, $payload);
    }

    /**
     * Returns the sample rate as set by BrickletIndustrialDualAnalogIn::setSampleRate().
     * 
     * 
     * @return int
     */
    public function getSampleRate()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_SAMPLE_RATE, $payload);

        $payload = unpack('C1rate', $data);

        return $payload['rate'];
    }

    /**
     * Sets offset and gain of MCP3911 internal calibration registers.
     * 
     * See MCP3911 datasheet 7.7 and 7.8. The Industrial Dual Analog In Bricklet
     * is already factory calibrated by Tinkerforge. It should not be necessary
     * for you to use this function
     * 
     * @param int[] $offset
     * @param int[] $gain
     * 
     * @return void
     */
    public function setCalibration($offset, $gain)
    {
        $payload = '';
        for ($i = 0; $i < 2; $i++) {
            $payload .= pack('V', $offset[$i]);
        }
        for ($i = 0; $i < 2; $i++) {
            $payload .= pack('V', $gain[$i]);
        }

        $this->sendRequest(self::FUNCTION_SET_CALIBRATION, $payload);
    }

    /**
     * Returns the calibration as set by BrickletIndustrialDualAnalogIn::setCalibration().
     * 
     * 
     * @return array
     */
    public function getCalibration()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_CALIBRATION, $payload);

        $payload = unpack('V2offset/V2gain', $data);

        $result['offset'] = IPConnection::collectUnpackedInt32Array($payload, 'offset', 2);
        $result['gain'] = IPConnection::collectUnpackedInt32Array($payload, 'gain', 2);

        return $result;
    }

    /**
     * Returns the ADC values as given by the MCP3911 IC. This function
     * is needed for proper calibration, see BrickletIndustrialDualAnalogIn::setCalibration().
     * 
     * 
     * @return array
     */
    public function getADCValues()
    {
        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_ADC_VALUES, $payload);

        $payload = unpack('V2value', $data);

        return IPConnection::collectUnpackedInt32Array($payload, 'value', 2);
    }

    /**
     * Returns the UID, the UID where the Bricklet is connected to, 
     * the position, the hardware and firmware version as well as the
     * device identifier.
     * 
     * The position can be 'a', 'b', 'c' or 'd'.
     * 
     * The device identifier numbers can be found :ref:`here <device_identifier>`.
     * |device_identifier_constant|
     * 
     * 
     * @return array
     */
    public function getIdentity()
    {
        $result = array();

        $payload = '';

        $data = $this->sendRequest(self::FUNCTION_GET_IDENTITY, $payload);

        $payload = unpack('c8uid/c8connected_uid/c1position/C3hardware_version/C3firmware_version/v1device_identifier', $data);

        $result['uid'] = IPConnection::implodeUnpackedString($payload, 'uid', 8);
        $result['connected_uid'] = IPConnection::implodeUnpackedString($payload, 'connected_uid', 8);
        $result['position'] = chr($payload['position']);
        $result['hardware_version'] = IPConnection::collectUnpackedArray($payload, 'hardware_version', 3);
        $result['firmware_version'] = IPConnection::collectUnpackedArray($payload, 'firmware_version', 3);
        $result['device_identifier'] = $payload['device_identifier'];

        return $result;
    }

    /**
     * Registers a callback with ID $id to the callable $callback.
     *
     * @param int $id
     * @param callable $callback
     * @param mixed $user_data
     *
     * @return void
     */
    public function registerCallback($id, $callback, $user_data = NULL)
    {
        if (!is_callable($callback)) {
            throw new \Exception('Callback function is not callable');
        }

        $this->registeredCallbacks[$id] = $callback;
        $this->registeredCallbackUserData[$id] = $user_data;
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperVoltage($data)
    {
        $result = array();
        $payload = unpack('C1channel/V1voltage', $data);

        array_push($result, $payload['channel']);
        array_push($result, IPConnection::fixUnpackedInt32($payload, 'voltage'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_VOLTAGE]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_VOLTAGE], $result);
    }

    /**
     * @internal
     * @param string $data
     */
    public function callbackWrapperVoltageReached($data)
    {
        $result = array();
        $payload = unpack('C1channel/V1voltage', $data);

        array_push($result, $payload['channel']);
        array_push($result, IPConnection::fixUnpackedInt32($payload, 'voltage'));
        array_push($result, $this->registeredCallbackUserData[self::CALLBACK_VOLTAGE_REACHED]);

        call_user_func_array($this->registeredCallbacks[self::CALLBACK_VOLTAGE_REACHED], $result);
    }
}

?>
